using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace mjs {
    public partial class FormScore : Form {
        Image Hai_Image;
        List<MJState_Result> results;

        public FormScore() {
            InitializeComponent();
        }

        public void SetData(List<MJState_Result> res,Image img) {
            Hai_Image = img;
            results = res;
            lstResults.Items.Clear();
            foreach(MJState_Result r in res) {
                lstResults.Items.Add(r);
            }
            lstResults.SelectedIndex = 0;
            lstResults.Refresh();
        }


        delegate void DrawSub(Hai h);

        private void listBox1_DrawItem(object sender, DrawItemEventArgs e) {
            int x = 0;
            MJState_Result r = (MJState_Result)lstResults.Items[e.Index];
            Font f = new Font("MS UI Gothic", 10);
            Bitmap bmp = new Bitmap(MainForm.HAI_WIDTH * 20, MainForm.HAI_HEIGHT);
            Graphics g = Graphics.FromImage(bmp);
            Image data = Hai_Image;
            
            Hai Agari = r.AgariHai;
            int[] Aka = (int[])r.numAkaDora.Clone();

            DrawSub draw_hai = delegate (Hai h) {
                int hi = (int)h;

                g.DrawImage(data, new Rectangle(x, 0, MainForm.HAI_WIDTH, MainForm.HAI_HEIGHT), MainForm.HaiToRect[(int)h], GraphicsUnit.Pixel);
                if(Agari == h) {
                    g.FillRectangle(new SolidBrush(Color.FromArgb(64, Color.Purple)), new Rectangle(x, 0, MainForm.HAI_WIDTH, MainForm.HAI_HEIGHT));
                    Agari = Hai.EMPTY;
                }
                x += 24;
            };

            e.DrawBackground();

            //\L
            e.Graphics.DrawString(string.Format("{0}_\n({1}) ", r.Score_Total, r.Score_Name),
                f, new SolidBrush(Color.DarkGray), e.Bounds.X + 2, e.Bounds.Y + 2);

            x = 0;

            foreach(Mentsu_State ms in r.ArrayMentsu) {
                if(ms.type == Mentsu.TOIZU) {
                    draw_hai(ms.top);
                    draw_hai(ms.top);
                }
                else if (ms.type == Mentsu.KOHZU) {
                    draw_hai(ms.top);
                    draw_hai(ms.top);
                    draw_hai(ms.top);
                    if(ms.naki) {
                        g.FillRectangle(new SolidBrush(Color.FromArgb(192, Color.LightBlue)),
                            new Rectangle(x-MainForm.HAI_WIDTH*3, 20, MainForm.HAI_WIDTH*3, MainForm.HAI_HEIGHT - 20));
                        g.DrawString("- | -", f,
                            new SolidBrush(Color.Black), x - MainForm.HAI_WIDTH*5/2, 20);
                    }
                }
                else if (ms.type == Mentsu.KANZU) {
                    draw_hai(ms.top);
                    draw_hai(ms.naki ? ms.top : Hai.URA);
                    draw_hai(ms.naki ? ms.top : Hai.URA);
                    draw_hai(ms.top);
                    g.FillRectangle(new SolidBrush(Color.FromArgb(192, Color.LightBlue)),
                        new Rectangle(x-MainForm.HAI_WIDTH*4, 20, MainForm.HAI_WIDTH*4, MainForm.HAI_HEIGHT - 20));
                        g.DrawString("- J -", f,
                            new SolidBrush(Color.Black), x - MainForm.HAI_WIDTH*3, 20);
                }
                else if(ms.type == Mentsu.SHUNZU) {
                    draw_hai(ms.top);
                    draw_hai(ms.top+1);
                    draw_hai(ms.top+2);
                    if(ms.naki) {
                        g.FillRectangle(new SolidBrush(Color.FromArgb(192, Color.LightBlue)),
                            new Rectangle(x-MainForm.HAI_WIDTH*3, 20, MainForm.HAI_WIDTH*3, MainForm.HAI_HEIGHT - 20));
                        g.DrawString("- `[ -", f,
                            new SolidBrush(Color.Black), x - MainForm.HAI_WIDTH*5/2, 20);
                    }
                }
                else if(ms.type == Mentsu.KOKUSHI) {
                    Hai[] kokushi_hai = new Hai[]{ Hai.MANZU_1, Hai.MANZU_9, Hai.PINZU_1, Hai.PINZU_9, Hai.SOUZU_1, Hai.SOUZU_9,
                        Hai.TON, Hai.NAN, Hai.SHA, Hai.PEI, Hai.HAKU, Hai.HATSU, Hai.CHUN};

                    foreach(Hai hi in kokushi_hai) {
                        draw_hai(hi);
                        if (hi == r.AgariHai) draw_hai(hi);
                    }
                }

                x+=3;
            }
            e.Graphics.DrawImage(bmp,e.Bounds.X + 90, e.Bounds.Y+1);

            e.DrawFocusRectangle();

        }

        private void butEnd_Click(object sender, EventArgs e) {
            this.Hide();
        }

        private void lstResults_SelectedIndexChanged(object sender, EventArgs e) {
            StringBuilder sb = new StringBuilder();
            //eLXg\
            if(lstResults.SelectedIndex == -1) {
                txtResult.Text = "";
                return;
            }

            MJState_Result res = (MJState_Result)lstResults.SelectedItem;

            sb.AppendFormat("{0} _ ",res.Score_Total);

            if(res.Score_Ko > 0) {
                //cオ
                if(res.Score_Oya > 0) {
                    sb.AppendFormat("(eF{0} _ qF{1}_) ",res.Score_Oya,res.Score_Ko);
                }
                else {
                    sb.AppendFormat("({0}_I[) ", res.Score_Ko);
                }
            }

            sb.AppendFormat(" F{0}",res.Score_Name);
            sb.AppendLine();
            sb.AppendLine(); 

            if(res.Score_Name.IndexOf("") == -1) {
                //̕\
                sb.AppendFormat("v {0}\n", res.Fu);
                sb.AppendLine(); 
                foreach(KeyValuePair<MJState_Fu, int> kvp in res.ArrayFu) {
                    sb.AppendFormat("  {0} F {1}", MJState_Resolver.Fu_Table[kvp.Key], kvp.Value);
                    sb.AppendLine(); 
                }
                sb.AppendLine();
                sb.AppendLine(); 
            }

            if(res.Score_Yakuman == 0) {
                //|̕\
                sb.AppendFormat("v {0}|", res.Han);
                sb.AppendLine(); 
                foreach(KeyValuePair<MJState_Yaku, int> kvp in res.ArrayYaku) {
                    sb.AppendFormat("  {0} F {1}|", MJState_Resolver.Yaku_Table[kvp.Key] ,kvp.Value);
                    sb.AppendLine(); 
                }
                sb.AppendLine();
            }
            else {
                //
                foreach (KeyValuePair<MJState_Yaku, int> kvp in res.ArrayYaku) {
                    sb.AppendFormat("  {0}", MJState_Resolver.Yaku_Table[kvp.Key]);
                    if(kvp.Value == 2)
                        sb.AppendFormat("(_u)");

                    sb.AppendLine();
                }
                sb.AppendLine();
            }
            txtResult.Text = sb.ToString();



        }
    }
}