using System;
using System.Collections.Generic;
using System.Text;

namespace mjs {


    public enum Kaze { TON, NAN, SHA, PEI };
    public enum Mentsu { KOHZU, TOIZU, KANZU, SHUNZU, KOKUSHI };
    public enum Hai {
        EMPTY = 0,
        MANZU_1 = 1, MANZU_2 = 2, MANZU_3 = 3, MANZU_4 = 4,
        MANZU_5 = 5, MANZU_6 = 6, MANZU_7 = 7, MANZU_8 = 8,
        MANZU_9 = 9, 
        PINZU_1 = 11, PINZU_2 = 12, PINZU_3 = 13, PINZU_4 = 14,
        PINZU_5 = 15, PINZU_6 = 16, PINZU_7 = 17, PINZU_8 = 18,
        PINZU_9 = 19, 
        SOUZU_1 = 21, SOUZU_2 = 22, SOUZU_3 = 23, SOUZU_4 = 24,
        SOUZU_5 = 25, SOUZU_6 = 26, SOUZU_7 = 27, SOUZU_8 = 28,
        SOUZU_9 = 29, 
        TON = 31, NAN = 32, SHA = 33, PEI = 34,
        HAKU = 36, HATSU = 37, CHUN = 38, URA = 40,
        DUMMY_MAX = 41,
    };
    public struct Mentsu_State {
        public Mentsu type;
        public bool naki;
        public Hai top; //\v
    };

    //
    public class MJState {
        public bool TsumoAgari = false;
        public int Richi = 0;
        public bool Ippatsu = false, Haitei = false, Rinshan = false, Chankan = false;


        public Kaze Jikaze = Kaze.TON;
        public Kaze Bakaze = Kaze.TON;
        public List<Mentsu_State> ArrayNaki = new List<Mentsu_State>();
        public List<Hai> OmoteDora = new List<Hai>();
        public List<Hai> UraDora = new List<Hai>();
        public List<Hai> Jihai = new List<Hai>();
        public Hai AgariHai = Hai.EMPTY;
    }

    //
    public enum MJState_Fu {
        FUTEI,
        MENZEN,
        TSUMO,

        KANCHAN,
        PENCHAN,
        TANKI,

        MINKOH,
        ANKOH,
        MINKAN,
        ANKAN,

        JANTOH,
        DUMMY_MAX,
    };
    public enum MJState_Yaku {
        DORA,            //h
        RICHI,           //[`
        IPPATSU,         //ꔭ
        TSUMO,           //[c(O̘a)
        TANYAO,          //^I(f)
        PINFU,           //a
        IPEIKO,          //u
        YAKUHAI,         //v
        RINSHAN,         //V(J)
        CHANKAN,         //`J()
        HAITEI,          //nCeC(ČE͒ꝝ)

        SANSHOKU_DOHJUN, //OF
        IKKITSUKAN,      //Cʊ
        CHANTA,          //`^(Sь)
        CHITOITSU,       //Ύq
        TOITOI,          //΁Xa
        SANANKO,         //OÍ
        HONROTO,         //V
        SANSHOKU_DOHKO,  //OF
        SANKANTSU,       //OȎq
        SHOSANGEN,       //O
        DOUBLE_RICHI,    //_u[`

        HONITSU,         //F
        JUNCHAN,         //W`(Sь)
        RYANPEIKO,       //u

        CHINITSU,         //F

        KOKUSHI,         //mo
        SUANKO,          //lÍ
        SUKANTSU,        //lȎq
        CHUREN,          //@
        DAISANGEN,       //O
        TSUISO,          //F
        SHOSUSHI,        //l
        DAISUSHI,        //l
        RYUISO,          //ΈF
        CHINROTO,        //V
        DAISHARIN,       //ԗ

        DUMMY_MAX,
    };

    public class MJState_Result {

        public string Score_Name = "";
        public int Score_Total = 0, Fu = 0, Han = 0;
        public int Score_Yakuman = 0;
        public int Score_Oya = 0, Score_Ko = 0;

        public int numOmoteDora = 0, numUraDora = 0, numYakuHai = 0;
        public int[] numAkaDora = { 0, 0, 0 };

        public Hai AgariHai = Hai.EMPTY;
        public List<Mentsu_State> ArrayMentsu = new List<Mentsu_State>(); //cꗗA擪͏オ

        public Dictionary<MJState_Yaku, int> ArrayYaku = new Dictionary<MJState_Yaku, int>();
        public Dictionary<MJState_Fu, int> ArrayFu = new Dictionary<MJState_Fu, int>();

    }


    class MJState_Resolver {
        public MJState state;
        public string ErrorStr = "";
        public List<MJState_Result> result;

        static public Dictionary<MJState_Yaku, string> Yaku_Table = new Dictionary<MJState_Yaku, string>();
        static public Dictionary<MJState_Fu, string> Fu_Table = new Dictionary<MJState_Fu, string>();

        private int[] numHai = new int[(int)Hai.DUMMY_MAX];
        private int numOmoteDora = 0, numUraDora = 0;
        static MJState_Resolver() {
            Yaku_Table.Add(MJState_Yaku.DORA, "h");
            Yaku_Table.Add(MJState_Yaku.RICHI, "[`");
            Yaku_Table.Add(MJState_Yaku.IPPATSU, "ꔭ");
            Yaku_Table.Add(MJState_Yaku.TSUMO, "[c(O̘a)");
            Yaku_Table.Add(MJState_Yaku.TANYAO, "^I(f)");
            Yaku_Table.Add(MJState_Yaku.PINFU, "a");
            Yaku_Table.Add(MJState_Yaku.IPEIKO, "u");
            Yaku_Table.Add(MJState_Yaku.YAKUHAI, "v");
            Yaku_Table.Add(MJState_Yaku.RINSHAN, "V(J)");
            Yaku_Table.Add(MJState_Yaku.CHANKAN, "`J()");
            Yaku_Table.Add(MJState_Yaku.HAITEI, "nCeC(ČE͒ꝝ)");
            Yaku_Table.Add(MJState_Yaku.SANSHOKU_DOHJUN, "OF");
            Yaku_Table.Add(MJState_Yaku.IKKITSUKAN, "Cʊ");
            Yaku_Table.Add(MJState_Yaku.CHANTA, "`^(Sь)");
            Yaku_Table.Add(MJState_Yaku.CHITOITSU, "Ύq");
            Yaku_Table.Add(MJState_Yaku.TOITOI, "΁Xa");
            Yaku_Table.Add(MJState_Yaku.SANANKO, "OÍ");
            Yaku_Table.Add(MJState_Yaku.HONROTO, "V");
            Yaku_Table.Add(MJState_Yaku.SANSHOKU_DOHKO, "OF");
            Yaku_Table.Add(MJState_Yaku.SANKANTSU, "OȎq");
            Yaku_Table.Add(MJState_Yaku.SHOSANGEN, "O");
            Yaku_Table.Add(MJState_Yaku.DOUBLE_RICHI, "_u[`");
            Yaku_Table.Add(MJState_Yaku.HONITSU, "F");
            Yaku_Table.Add(MJState_Yaku.JUNCHAN, "W`(Sь)");
            Yaku_Table.Add(MJState_Yaku.RYANPEIKO, "u");
            Yaku_Table.Add(MJState_Yaku.CHINITSU, "F");
            Yaku_Table.Add(MJState_Yaku.KOKUSHI, "mo");
            Yaku_Table.Add(MJState_Yaku.SUANKO, "lÍ");
            Yaku_Table.Add(MJState_Yaku.CHUREN, "@");
            Yaku_Table.Add(MJState_Yaku.DAISANGEN, "O");
            Yaku_Table.Add(MJState_Yaku.TSUISO, "F");
            Yaku_Table.Add(MJState_Yaku.SHOSUSHI, "l");
            Yaku_Table.Add(MJState_Yaku.DAISUSHI, "l");
            Yaku_Table.Add(MJState_Yaku.SUKANTSU, "lȎq");
            Yaku_Table.Add(MJState_Yaku.RYUISO, "ΈF");
            Yaku_Table.Add(MJState_Yaku.CHINROTO, "V");
            Yaku_Table.Add(MJState_Yaku.DAISHARIN, "ԗ");
            Fu_Table.Add(MJState_Fu.FUTEI, "");
            Fu_Table.Add(MJState_Fu.MENZEN, "O");
            Fu_Table.Add(MJState_Fu.TSUMO, "c");
            Fu_Table.Add(MJState_Fu.KANCHAN, "J`҂");
            Fu_Table.Add(MJState_Fu.PENCHAN, "y`҂");
            Fu_Table.Add(MJState_Fu.TANKI, "PR҂");
            Fu_Table.Add(MJState_Fu.MINKOH, "q");
            Fu_Table.Add(MJState_Fu.ANKOH, "Íq");
            Fu_Table.Add(MJState_Fu.MINKAN, "Ȏq");
            Fu_Table.Add(MJState_Fu.ANKAN, "ÞȎq");
            Fu_Table.Add(MJState_Fu.JANTOH, "");

        }
        private void CountDora() {
            //ԃh̓JEgς
            int i;

            //{̓Jh͍̐Œ(vC[̃J)+(`JȂ1)͂A
            //͂܂ŌɃJEgȂB

            foreach (Hai h in state.OmoteDora) {
                i = (int)h;
                //̔v
                if (i == 9 || i == 19 || i == 29) i = i - 8;
                else if (i == 34) i = 31;
                else if (i == 38) i = 36;
                else i = i + 1;
                numOmoteDora += numHai[i];
            }
            foreach (Hai h in state.UraDora) {
                i = (int)h;
                //̔v
                if (i == 9 || i == 19 || i == 29) i = i - 8;
                else if (i == 34) i = 31;
                else if (i == 38) i = 36;
                else i = i + 1;
                numUraDora += numHai[i];
            }

        }
        
        private void CountHaiPattern(string pat, out int inc, out int exc) {
            //p^[0/1̕ŕ\Avv̐ƂłȂJEg
            int i, target_hai;
            bool target_b;
            string tmp;

            //󔒂
            tmp = pat.Replace(" ", "") + "0000000000000000000000000000000000";
            inc = exc = 0;

            for (i = 0; i < 34; i++) {
                //JEgΏۓH
                target_b = (tmp.Substring(i, 1) == "1");

                if (i < 9) target_hai = (int)Hai.MANZU_1 + i;
                else if (i < 18) target_hai = (int)Hai.PINZU_1 + (i - 9);
                else if (i < 27) target_hai = (int)Hai.SOUZU_1 + (i - 18);
                else if (i < 31) target_hai = (int)Hai.TON + (i - 27);
                else target_hai = (int)Hai.HAKU + (i - 31);

                if (target_b)
                    inc += numHai[target_hai];
                else
                    exc += numHai[target_hai];
            }

        }

        private void CheckYaku_Richi(MJState_Result mjr) {
            //[`E_u[`
            if (state.Richi == 1) mjr.ArrayYaku.Add(MJState_Yaku.RICHI, 1);
            if (state.Richi == 2) mjr.ArrayYaku.Add(MJState_Yaku.DOUBLE_RICHI, 2);
            return;
        }

        private void CheckYaku_Tsumo(MJState_Result mjr) {
            //cɔ̔(cEꔭE`JEV)

            //cオȊO͕s
            if (!state.TsumoAgari)
                return;

            bool naki = false;
            //|E`[E~JNG
            foreach (Mentsu_State ms in state.ArrayNaki) {
                if (ms.naki)
                    naki = true;
            }

            //Ȃ΃c
            if (!naki)
                mjr.ArrayYaku.Add(MJState_Yaku.TSUMO, 1);

            //[`Έꔭ̉\
            if (state.Ippatsu && state.Richi > 0)
                mjr.ArrayYaku.Add(MJState_Yaku.IPPATSU, 1);

            //`J̓オ舵(ł͋tɃc̎̓`JȂ)
            if (state.Chankan && !state.TsumoAgari)
                mjr.ArrayYaku.Add(MJState_Yaku.CHANKAN, 1);

            //V̓cオ舵ŁAJƂ̂ݔ
            if (state.Rinshan) {
                bool kan = false;
                //JEÃJOK
                foreach (Mentsu_State ms in state.ArrayNaki) {
                    if (ms.type == Mentsu.KANZU) kan = true;
                }
                if (kan)
                    mjr.ArrayYaku.Add(MJState_Yaku.RINSHAN, 1);
            }

            return;
        }

        private void CheckYaku_Yakuhai(MJState_Result mjr) {
            int yaku = 0;

            //qEJŁAvT
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {
                if (ms.type == Mentsu.KANZU || ms.type == Mentsu.KOHZU) {
                    //ᢒ1
                    if (ms.top >= Hai.HAKU && ms.top <= Hai.CHUN)
                        yaku++;
                    //ꕗɈv
                    if ((int)ms.top - (int)Hai.TON == (int)state.Bakaze)
                        yaku++;
                    //̕Ɉv
                    if ((int)ms.top - (int)Hai.TON == (int)state.Jikaze)
                        yaku++;
                }
            }

            if (yaku > 0)
                mjr.ArrayYaku.Add(MJState_Yaku.YAKUHAI, yaku);
        }

        private void CheckYaku_Haitei(MJState_Result mjr) {
            //nCeC͖ⓚpŖ
            if (state.Haitei)
                mjr.ArrayYaku.Add(MJState_Yaku.HAITEI, 1);
        }

        private void CheckYaku_Tanyao(MJState_Result mjr) {
            //^IƂ̔΂̍V̔
            //łɃ`^E`
            int inc, exc;
            int num_jihai = 0, num_digit = 0;

            //2-8v̌
            CountHaiPattern("011111110 011111110 011111110 0000 000", out inc, out exc);

            if (exc == 0) {
                //S2-8vȂ^I
                mjr.ArrayYaku.Add(MJState_Yaku.TANYAO, 1);
                return;
            }

            if (inc == 0) {
                //S2-8vłȂȂ獬V
                mjr.ArrayYaku.Add(MJState_Yaku.HONROTO,2);

                //Vƃ`^͏dȂ̂łŔ
                return;
            }

            //`^E`Ώۓ̖𔻒
            //q̏ꍇ̂ŁAv̐ŔłȂ
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {
                //vok
                if (ms.top >= Hai.TON) num_jihai++;
                else {
                    if (ms.type == Mentsu.SHUNZU) {
                        //qȂ擪17̂ok
                        if (ms.top != Hai.MANZU_1 && ms.top != Hai.MANZU_7 && ms.top != Hai.SOUZU_1
                            && ms.top != Hai.SOUZU_7 && ms.top != Hai.PINZU_1 && ms.top != Hai.PINZU_7)
                            return;
                    }
                    else {
                        //qȊOȂ1E9ȊOs
                        if (ms.top != Hai.MANZU_1 && ms.top != Hai.MANZU_9 && ms.top != Hai.SOUZU_1
                            && ms.top != Hai.SOUZU_9 && ms.top != Hai.PINZU_1 && ms.top != Hai.PINZU_9)
                            return;
                    }
                    num_digit++;
                }
            }

            //F͔ς݂Ȃ̂ŁAnum_digit0Ȃ̂͂蓾Ȃc
            if (num_digit > 0) {
                if (num_jihai == 0) {
                    //vȂΏ`
                    //̗LłPʉ
                    mjr.ArrayYaku.Add(MJState_Yaku.JUNCHAN, (state.ArrayNaki.Count > 0 ? 2 : 3));
                }
                else {
                    //`^
                    //̗LłPʉ
                    mjr.ArrayYaku.Add(MJState_Yaku.CHANTA, (state.ArrayNaki.Count > 0 ? 1 : 2));
                }
            }
        }

        private void CheckYaku_Chinitsu(MJState_Result mjr) {
            //FƐF̔
            bool ok = false;
            int inc, exc;

            //̌A}YA\EYAsY̍\邩H
            CountHaiPattern("111111111 000000000 000000000 0000 000", out inc, out exc);
            ok |= (exc == 0);

            CountHaiPattern("000000000 111111111 000000000 0000 000", out inc, out exc);
            ok |= (exc == 0);

            CountHaiPattern("000000000 000000000 111111111 0000 000", out inc, out exc);
            ok |= (exc == 0);

            if (ok) {
                //Fm
                mjr.ArrayYaku.Add(MJState_Yaku.CHINITSU, (state.ArrayNaki.Count == 0 ? 6 : 5));
                return;
            }

            //F̔
            CountHaiPattern("111111111 000000000 000000000 1111 111", out inc, out exc);
            ok |= (exc == 0);

            CountHaiPattern("000000000 111111111 000000000 1111 111", out inc, out exc);
            ok |= (exc == 0);

            CountHaiPattern("000000000 000000000 111111111 1111 111", out inc, out exc);
            ok |= (exc == 0);

            if (ok) {
                //Fm
                mjr.ArrayYaku.Add(MJState_Yaku.HONITSU, (state.ArrayNaki.Count == 0 ? 3 : 2));
                return;
            }
        }

        private void CheckYaku_Sananko(MJState_Result mjr) {
            //OÍEOȎqE΁Xa̔
            int anko = 0, kantsu = 0, kohzu = 0;

            foreach (Mentsu_State ms in mjr.ArrayMentsu) {

                //ĂȂqEȎq͈ÍJEg
                if (ms.type == Mentsu.KOHZU || ms.type == Mentsu.KANZU) {
                    kohzu++;
                    if (ms.naki == false) anko++;
                }
                //ȎqJEg
                if (ms.type == Mentsu.KANZU)
                    kantsu++;
            }


            if (kantsu == 3) {
                //OȎqm
                mjr.ArrayYaku.Add(MJState_Yaku.SANKANTSU, 2);
            }
            if (anko == 3) {
                //OÍm
                mjr.ArrayYaku.Add(MJState_Yaku.SANANKO, 2);
            }
            if (kohzu == 4) {
                //΁Xam
                mjr.ArrayYaku.Add(MJState_Yaku.TOITOI, 2);
            }

        }

        private void CheckYaku_Shosangen(MJState_Result mjr) {
            //O
            int kohzu = 0;

            //EᢁESQȏŁAQ͂Rȏ
            //܂2ȏȂvƃAEg
            if (numHai[(int)Hai.HAKU] < 2 || numHai[(int)Hai.HATSU] < 2 || numHai[(int)Hai.CHUN] < 2)
                return;
            //Rȏ゠vJEgAQok
            if (numHai[(int)Hai.HAKU] >= 3) kohzu++;
            if (numHai[(int)Hai.HATSU] >= 3) kohzu++;
            if (numHai[(int)Hai.CHUN] >= 3) kohzu++;

            if (kohzu == 2)
                mjr.ArrayYaku.Add(MJState_Yaku.SHOSANGEN, 2);

            return;
        }

        private void CheckYaku_Pinfu(MJState_Result mjr) {
            //stقAqn̖(uEuECʊсEOF)𔻒
            //@Ă̂ŁAOF
            int num_shunzu = 0;
            int[] num_shunzu_top = new int[(int)Hai.DUMMY_MAX];
            int[] num_kohzu_top = new int[(int)Hai.DUMMY_MAX];
            Mentsu_State jantoh = new Mentsu_State();

            //qE̐JEg
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {

                //oĂ
                if (ms.type == Mentsu.TOIZU) jantoh = ms;

                //qEqEȎq̐擪vJEg
                if (ms.type == Mentsu.SHUNZU) {
                    num_shunzu_top[(int)ms.top]++;
                    num_shunzu++;
                }
                else if (ms.type == Mentsu.KOHZU || ms.type == Mentsu.KANZU) {
                    num_kohzu_top[(int)ms.top]++;
                }
            }

            if (state.ArrayNaki.Count == 0) {
                //stEuEu͖ĂȂƂ

                //st
                //ׂďqŁAʑ҂Ȃƕs
                if (num_shunzu == 4 && mjr.ArrayMentsu[0].type == Mentsu.SHUNZU) {
                    //q̐̏オvŁA7łȂȂok
                    //́Aq̐̑傫オvŁA1łȂȂok
                    //ȊO̓J`Ey`ɂȂ̂ŕs
                    if ((mjr.ArrayMentsu[0].top == state.AgariHai && ((int)mjr.ArrayMentsu[0].top % 10) != 7) ||
                        (mjr.ArrayMentsu[0].top + 2 == state.AgariHai && ((int)mjr.ArrayMentsu[0].top % 10) != 1)) {

                        //ɁAȂ
                        //ᢒyѕƈvȂ΂悢
                        if ((!(jantoh.top >= Hai.HAKU && jantoh.top <= Hai.CHUN)) && ((int)(jantoh.top - Hai.TON) != (int)state.Jikaze) &&
                            ((int)(jantoh.top - Hai.TON) != (int)state.Bakaze)) {
                            mjr.ArrayYaku.Add(MJState_Yaku.PINFU, 1);
                        }


                    }
                    
                }

                //uEu
                //̂Qg̏q̂𐔂
                int num_ipeiko = 0;
                for (int i = 0; i < (int)Hai.DUMMY_MAX; i++) {
                    if (num_shunzu_top[i] >= 2) num_ipeiko++;
                }

                if (num_ipeiko == 1)
                    mjr.ArrayYaku.Add(MJState_Yaku.IPEIKO, 1);
                if (num_ipeiko == 2)
                    mjr.ArrayYaku.Add(MJState_Yaku.RYANPEIKO, 2);
            }

            for (int i = 1; i <= 9; i++) {
                //eF̏qΎOF
                if (num_shunzu_top[i] > 0 && num_shunzu_top[i + 10] > 0 && num_shunzu_top[i + 20] > 0) {
                    mjr.ArrayYaku.Add(MJState_Yaku.SANSHOKU_DOHJUN, (state.ArrayNaki.Count == 0 ? 2 : 1));
                }
                //eF̍qΎOF
                if (num_kohzu_top[i] > 0 && num_kohzu_top[i + 10] > 0 && num_kohzu_top[i + 20] > 0) {
                    mjr.ArrayYaku.Add(MJState_Yaku.SANSHOKU_DOHKO, 2);
                }
            }

            //Cʊє
            //eF1E4E7擪̏q΂悢
            if ((num_shunzu_top[1] > 0 && num_shunzu_top[4] > 0 && num_shunzu_top[7] > 0) ||
                (num_shunzu_top[11] > 0 && num_shunzu_top[14] > 0 && num_shunzu_top[17] > 0) ||
                (num_shunzu_top[21] > 0 && num_shunzu_top[24] > 0 && num_shunzu_top[27] > 0)) {
                mjr.ArrayYaku.Add(MJState_Yaku.IKKITSUKAN, (state.ArrayNaki.Count == 0 ? 2 : 1));
            }



        }

        private void CheckYaku_Chitoitsu(MJState_Result mjr) {
            //Ύq

            //ʎq7Ίm
            if(mjr.ArrayMentsu.Count == 7)
                    mjr.ArrayYaku.Add(MJState_Yaku.CHITOITSU, 2);
        }

        private void CheckYaku_Dora(MJState_Result mjr) {

            //\hJEg
            int numDora = numOmoteDora;
            //[`ĂȂ痠hJEg
            if (state.Richi > 0) numDora += numUraDora;

            if (numDora > 0)
                mjr.ArrayYaku.Add(MJState_Yaku.DORA, numDora);
        }



        //𖞔̃XRA

        #region 𖞔
        private void YakumanResult(MJState_Result mjr, int count) {
            //オv2ȂQ{
            mjr.Score_Yakuman += count;

            if (state.Jikaze == Kaze.TON) {
                //e
                if(state.TsumoAgari)
                    mjr.Score_Ko = 16000 * mjr.Score_Yakuman;
                mjr.Score_Total = 48000 * mjr.Score_Yakuman;
            }
            else {
                //q
                if(state.TsumoAgari) {
                    mjr.Score_Oya = 16000 * mjr.Score_Yakuman;
                    mjr.Score_Ko = 8000 * mjr.Score_Yakuman;
                }
                mjr.Score_Total = 32000 * mjr.Score_Yakuman;
            }


            if (mjr.Score_Yakuman == 1)
                mjr.Score_Name = "";
            else if (mjr.Score_Yakuman == 2)
                mjr.Score_Name = "d";
            else if (mjr.Score_Yakuman == 3)
                mjr.Score_Name = "Od";
            else if (mjr.Score_Yakuman == 4)
                mjr.Score_Name = "ld";
        }
        private bool CheckYaku_Tsuiso(MJState_Result mjr) {
            int inc, exc;
            //F

            //v̂
            CountHaiPattern("000000000 000000000 000000000 1111 111", out inc, out exc);
            if (exc > 0) return false;

            //F
            YakumanResult(mjr, 1);
            mjr.ArrayYaku.Add(MJState_Yaku.TSUISO, 1);

            return true;
        }

        private bool CheckYaku_Daisangen(MJState_Result mjr) {
            //O

            //EᢁESRȏ
            if (numHai[(int)Hai.HAKU] < 3) return false;
            if (numHai[(int)Hai.HATSU] < 3) return false;
            if (numHai[(int)Hai.CHUN] < 3) return false;


            YakumanResult(mjr, 1);
            mjr.ArrayYaku.Add(MJState_Yaku.DAISANGEN, 1);

            return true;
        }

        private bool CheckYaku_Suankoh(MJState_Result mjr) {
            //lÍElȎq
            int num_ankoh = 0, num_kan = 0, yaku;

            //ÍEȎq̐𐔂
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {
                if (ms.type == Mentsu.KANZU) num_kan++;
                if (!ms.naki && (ms.type == Mentsu.KANZU || ms.type == Mentsu.KOHZU)) num_ankoh++;
            }

            //PRȂ_u
            yaku = (mjr.ArrayMentsu[0].type == Mentsu.TOIZU ? 2 : 1);
            //lȎq
            if (num_kan == 4) {
                YakumanResult(mjr, yaku);
                mjr.ArrayYaku.Add(MJState_Yaku.SUKANTSU, yaku);
                return true;
            }

            //lÍ
            if (num_ankoh == 4) {
                YakumanResult(mjr, yaku);
                mjr.ArrayYaku.Add(MJState_Yaku.SUANKO, yaku);
                return true;
            }
            return false;

        }

        private bool CheckYaku_Sushi(MJState_Result mjr) {
            //lEl
            int[] num_dir = new int[4];
            int n;

            //ÍEȎq̐𐔂BȎq3ƃJEgB
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {
                if (ms.top >= Hai.TON && ms.top <= Hai.PEI) {
                    if (ms.type == Mentsu.TOIZU) num_dir[ms.top - Hai.TON] = 2;
                    else num_dir[ms.top - Hai.TON] = 3;
                }
            }

            //4̍v́H
            n = num_dir[0] + num_dir[1] + num_dir[2] + num_dir[3];

            //l
            if (n == 11) {
                YakumanResult(mjr, 1);
                mjr.ArrayYaku.Add(MJState_Yaku.SHOSUSHI, 1);
                return true;
            }

            //l
            if (n == 12) {
                YakumanResult(mjr, 2);
                mjr.ArrayYaku.Add(MJState_Yaku.DAISUSHI, 2);
                return true;
            }
            return false;

        }

        private bool CheckYaku_Daisharin(MJState_Result mjr) {
            //ԗ֔
            //sY2-8Q
            int i;

            //Ύq̂ok
            if(mjr.ArrayMentsu.Count != 7) return false;

            for (i = (int)Hai.PINZU_2; i <= (int)Hai.PINZU_8; i++) {
                if (numHai[i] != 2) return false;
            }

            //ԗ֊m
            YakumanResult(mjr, 1);

            mjr.ArrayYaku.Add(MJState_Yaku.DAISHARIN, 1);
            return true;
        }

        private bool CheckYaku_Churen(MJState_Result mjr) {
            //@󓕔
            //ʎq͌ȂĂŔ\
            int i,j;
            Hai h = Hai.EMPTY;

            //Ăꍇ͕sBÞȂ_B
            if(state.ArrayNaki.Count > 0)
                return false;

            //eFŔ
            for(j=0;j<3;j++) {
                h = Hai.EMPTY;
                for (i = 1; i <= 9; i++) {
                    if (i == 1 || i == 9) {
                        //19͂RBSvPނĂ悢B
                        if (numHai[i+j*10] == 4) {
                            if (h != Hai.EMPTY) break;
                            else h = (Hai)(i+j*10);
                        }
                        else if (numHai[i+j*10] != 3) {
                            break;
                        }
                    }
                    else {
                        //2`81B2vPނĂ悢B
                        if (numHai[i+j*10] == 2) {
                            if (h != Hai.EMPTY) break;
                            else h = (Hai)(i + j * 10);
                        }
                        else if (numHai[i+j*10] != 1) {
                            break;
                        }
                    }

                }

                if (h != Hai.EMPTY) {

                    //PvオvȂAŃ_u
                    if (h == state.AgariHai) i = 2;
                    else i = 1;

                    YakumanResult(mjr, i);
                    mjr.ArrayYaku.Add(MJState_Yaku.CHUREN, i);
                    return true;
                }
            }
            return false;

        }

        private bool CheckYaku_Ryuiso(MJState_Result mjr) {
            //ΈF
            //ʎq͌ȂĂAv̐ŔfłB
            int inc, exc;

            //2,3,4,6,8\Eyᢂ̐JEg
            CountHaiPattern("000000000 000000000 011101010 0000 010", out inc, out exc);
            if (exc > 0)
                return false;


            YakumanResult(mjr, 1);
            mjr.ArrayYaku.Add(MJState_Yaku.RYUISO, 1);
            return true;
        }

        private bool CheckYaku_Chinroto(MJState_Result mjr) {
            //V
            //ʎq͌ȂĂAv̐ŔfłB
            int inc, exc;

            //1E9̂
            CountHaiPattern("100000001 100000001 100000001 0000 000", out inc, out exc);
            if (exc > 0)
                return false;

            YakumanResult(mjr, 1);
            mjr.ArrayYaku.Add(MJState_Yaku.CHINROTO, 1);
            return true;
        }

        private bool CheckYaku_Kokushi() {
            //mo̔
            MJState_Result mjr = new MJState_Result();
            Hai[] HaiList = { Hai.MANZU_1, Hai.MANZU_9, Hai.PINZU_1, Hai.PINZU_9, Hai.SOUZU_1, Hai.SOUZU_9,
                Hai.HAKU, Hai.HATSU, Hai.CHUN, Hai.TON, Hai.NAN, Hai.SHA, Hai.PEI};
            Hai toitsu_hai = Hai.EMPTY;

            foreach (Hai h in HaiList) {
                //_v1ȂȂ獑mɂȂȂ
                if (numHai[(int)h] == 0) return false;
                if (numHai[(int)h] == 2) toitsu_hai = h;
            }

            //2vȂȂs
            if (toitsu_hai == Hai.EMPTY) return false;

            mjr = new MJState_Result();
            mjr.AgariHai = state.AgariHai;

            Mentsu_State ms = new Mentsu_State();
            ms.type = Mentsu.KOKUSHI;
            // topɂ2voĂ
            ms.top = toitsu_hai;
            mjr.ArrayMentsu.Add(ms);

            //オv̐==𖞂̑dx
            YakumanResult(mjr, numHai[(int)state.AgariHai]);

            mjr.ArrayYaku.Add(MJState_Yaku.KOKUSHI, mjr.Score_Yakuman);
            result.Add(mjr);
            return true;
        }
        #endregion

        //̌vZ
        private void Count_Fu(MJState_Result mjr) {

            //vZ
            if(mjr.ArrayMentsu.Count == 7 ){
                //Ύq͓25AŊmȂ̂ŏI
                mjr.ArrayFu.Add(MJState_Fu.FUTEI, 25);
                return;

            }

            Dictionary<MJState_Fu, int> dic_fu = new Dictionary<MJState_Fu,int>();

            //[̃Xg𖄂߂Ă
            for(int i = 0; i<(int)MJState_Fu.DUMMY_MAX ; i++) {
                dic_fu.Add((MJState_Fu)i, 0);
            }

            //ΎqȊOA20
            dic_fu[MJState_Fu.FUTEI] = 20;

            //ȂAcオȂʑO10
            if(state.ArrayNaki.Count == 0 && !state.TsumoAgari)
                dic_fu[MJState_Fu.MENZEN] = 10;

            //c
            if(state.TsumoAgari)
                dic_fu[MJState_Fu.TSUMO] = 2;

            //擪qȂJ`Ey`҂̉\
            if(mjr.ArrayMentsu[0].type == Mentsu.SHUNZU) {
                //オvq̐擪̎ȂJ`
                if(state.AgariHai == mjr.ArrayMentsu[0].top+1)
                    dic_fu[MJState_Fu.KANCHAN] = 2;

                //123̕т3A7897ŏオƂAy`
                if( (((int)state.AgariHai % 10 == 3) && ((int)mjr.ArrayMentsu[0].top % 10 == 1)) ||
                    (((int)state.AgariHai % 10 == 7) && ((int)mjr.ArrayMentsu[0].top % 10 == 7)))
                    dic_fu[MJState_Fu.PENCHAN] = 2;
            }

            //擪ȂPR҂
            if(mjr.ArrayMentsu[0].type == Mentsu.TOIZU)
                dic_fu[MJState_Fu.TANKI] = 2;

            //EqEȎq̕vZ
            foreach (Mentsu_State ms in mjr.ArrayMentsu) {
                if(ms.type == Mentsu.TOIZU) {
                    //

                    //Ov͂Q
                    if(ms.top >= Hai.HAKU && ms.top <= Hai.CHUN)
                        dic_fu[MJState_Fu.JANTOH] += 2;
                    //v͕r
                    if ((int)(ms.top - Hai.TON) == (int)state.Jikaze)
                        dic_fu[MJState_Fu.JANTOH] += 2;
                    if ((int)(ms.top - Hai.TON) == (int)state.Bakaze)
                        dic_fu[MJState_Fu.JANTOH] += 2;
                    
                }
                else if(ms.type == Mentsu.KOHZU || ms.type == Mentsu.KANZU) {
                    int score = 2;
                    //19v͂Q{
                    if(ms.top >= Hai.TON || ((int)ms.top % 10 == 1) || ((int)ms.top % 10 == 9))
                        score *= 2;

                    if (ms.type == Mentsu.KOHZU && ms.naki)
                        dic_fu[MJState_Fu.MINKOH] = dic_fu[MJState_Fu.MINKOH] + score;
                    else if (ms.type == Mentsu.KOHZU && !ms.naki)
                        dic_fu[MJState_Fu.ANKOH] = dic_fu[MJState_Fu.ANKOH] + score * 2;
                    else if (ms.type == Mentsu.KANZU && ms.naki)
                        dic_fu[MJState_Fu.MINKAN] = dic_fu[MJState_Fu.MINKAN] + score * 4;
                    else if (ms.type == Mentsu.KANZU && !ms.naki)
                        dic_fu[MJState_Fu.ANKAN] = dic_fu[MJState_Fu.ANKAN] + score * 8; 
                }
            }

            //0ȊO̍ڂǉ
            foreach(MJState_Fu f in dic_fu.Keys) {
                if(dic_fu[f] != 0) mjr.ArrayFu[f] = dic_fu[f];
            }
            

        }

        //ʂXRAvZ
        private void Calc_Score_fin(MJState_Result mjr) {
            

            mjr.Fu = mjr.Han = 0;
            //܂v̕ʂvZ
            foreach(int fu in mjr.ArrayFu.Values) {
                mjr.Fu += fu;
            }
            //ΎqȊO10̔{ɐ؂グ
            if(mjr.Fu != 25)
                mjr.Fu = ((mjr.Fu + 9)/10)*10;

            foreach (int han in mjr.ArrayYaku.Values) {
                mjr.Han += han;
            }

            //Pl̃XRA
            int score_for_one = mjr.Fu << (2+mjr.Han);
            
            //шȏ̔
            if(mjr.Han >= 13) {
                score_for_one = 8000;
                mjr.Score_Name = "";
            }
            else if (mjr.Han >= 11) {
                score_for_one = 6000;
                mjr.Score_Name = "O{";
            }
            else if (mjr.Han >= 8) {
                score_for_one = 4000;
                mjr.Score_Name = "{";
            }
            else if (mjr.Han >= 6) {
                score_for_one = 3000;
                mjr.Score_Name = "";
            }
            else if (score_for_one >= 2000) {
                score_for_one = 2000;
                mjr.Score_Name = "";
            }
            else {
                mjr.Score_Name = string.Format("{0}{1}|",mjr.Fu,mjr.Han);
            }

            if(state.Jikaze == Kaze.TON) {
                //ȅꍇ
                if(state.TsumoAgari) {
                    //c
                    mjr.Score_Ko = score_for_one * 2;
                    //100̔{ɐ؂グĂ瑫
                    mjr.Score_Ko = ((mjr.Score_Ko + 99) / 100) * 100;
                    mjr.Score_Total = mjr.Score_Ko * 3;
                }
                else {
                    //
                    //Ōɐ؂グ
                    mjr.Score_Total = score_for_one * 6;
                    mjr.Score_Total = ((mjr.Score_Total + 99) / 100) * 100;

                }
            }
            else if (state.Jikaze != Kaze.TON) {
                //q̏ꍇ
                if(state.TsumoAgari) {
                    mjr.Score_Ko = score_for_one;
                    mjr.Score_Oya = score_for_one * 2;
                    //100̔{ɐ؂グ
                    mjr.Score_Ko = ((mjr.Score_Ko + 99) / 100) * 100;
                    mjr.Score_Oya = ((mjr.Score_Oya + 99) / 100) * 100;

                    mjr.Score_Total = mjr.Score_Ko * 2 + mjr.Score_Oya;
                }
                else {
                    //
                    //Ōɐ؂グ
                    mjr.Score_Total = score_for_one * 4;
                    mjr.Score_Total = ((mjr.Score_Total + 99) / 100) * 100;
                }
            }

        }


        #region ʎq

        //TAꂩc̖ʎqT
        private void Enum_Jantoh(List<List<Mentsu_State>> ArrayPattern, List<Mentsu_State> Pattern, int[] numHai_tmp) {
            Mentsu_State m;
            int i;

            for (i = 0; i < numHai_tmp.Length; i++) {
                if (numHai_tmp[i] >= 2) {
                    m = new Mentsu_State();
                    m.top = (Hai)i;
                    m.type = Mentsu.TOIZU;
                    Pattern.Add(m);
                    numHai_tmp[i] -= 2;
                    Enum_Mentsu(ArrayPattern, Pattern, numHai_tmp, 0);
                    //T͏Ԃ߂
                    numHai_tmp[i] += 2;
                    Pattern.RemoveAt(Pattern.Count - 1);
                }
            }

        }

        private void Enum_Mentsu(List<List<Mentsu_State>> ArrayPattern, List<Mentsu_State> Pattern, int[] numHai_tmp, int pos) {
            Mentsu_State m;
            int i, total = 0;

            //ȂI
            for (i = 0; i < numHai_tmp.Length; i++) total += numHai_tmp[i];
            if (total == 0) {
                //Pattern̒g͍ėp邽߂̂܂AddARs[đ}
                List<Mentsu_State> PatternClone = new List<Mentsu_State>(Pattern);
                //łɊmς݂̖ʎqǉ
                PatternClone.AddRange(state.ArrayNaki);
                ArrayPattern.Add(new List<Mentsu_State>(PatternClone));
                return;
            }

            //c肪3̔{łȂȂ炨
            if (total % 3 != 0) return;

            //ʒuposoĂƂŁAʎqւ̏dh
            for (i = pos; i < numHai_tmp.Length; i++) {
                //q
                if (numHai_tmp[i] >= 3) {
                    m = new Mentsu_State();
                    m.top = (Hai)i;
                    m.type = Mentsu.KOHZU;
                    Pattern.Add(m);

                    //cT
                    numHai_tmp[i] -= 3;
                    Enum_Mentsu(ArrayPattern, Pattern, numHai_tmp, i);
                    //T͏Ԃ߂
                    numHai_tmp[i] += 3;
                    Pattern.RemoveAt(Pattern.Count - 1);
                }

                //q
                if (i <= (int)Hai.SOUZU_9 && i % 10 <= 7 && numHai_tmp[i] >= 1 && numHai_tmp[i + 1] >= 1 && numHai_tmp[i + 2] >= 1) {
                    m = new Mentsu_State();
                    m.top = (Hai)i;
                    m.type = Mentsu.SHUNZU;
                    Pattern.Add(m);

                    //cT
                    numHai_tmp[i]--;
                    numHai_tmp[i + 1]--;
                    numHai_tmp[i + 2]--;
                    Enum_Mentsu(ArrayPattern, Pattern, numHai_tmp, i);
                    //T͏Ԃ߂
                    Pattern.RemoveAt(Pattern.Count - 1);
                    numHai_tmp[i]++;
                    numHai_tmp[i + 1]++;
                    numHai_tmp[i + 2]++;
                }
            }


        }

        private void Enum_Patterm(List<List<Mentsu_State>> ArrayPattern) {
            int i;
            int[] numHai_tmp = new int[41];
            //肦p^[
            List<Mentsu_State> Pattern;
            Mentsu_State m;

            //܂ł͓+Sʎq
            //_vZȂǂ͌ōs

            //vo
            for (i = 0; i < numHai_tmp.Length; i++) numHai_tmp[i] = 0;
            foreach (Hai h in state.Jihai) numHai_tmp[(int)h]++;
            numHai_tmp[(int)state.AgariHai]++;





            //オv2ȏ゠ȂAPR҂p^[
            if (numHai_tmp[(int)state.AgariHai] >= 2) {
                Pattern = new List<Mentsu_State>();
                m = new Mentsu_State();
                m.top = state.AgariHai;
                m.type = Mentsu.TOIZU;
                Pattern.Add(m);
                //Ac̖ʎq
                numHai_tmp[(int)state.AgariHai] -= 2;
                Enum_Mentsu(ArrayPattern, Pattern, numHai_tmp, 0);
                numHai_tmp[(int)state.AgariHai] += 2;
            }

            //オv3ȏ゠ȂAqオp^[
            if (numHai_tmp[(int)state.AgariHai] >= 3) {
                Pattern = new List<Mentsu_State>();
                m = new Mentsu_State();
                m.top = state.AgariHai;
                m.type = Mentsu.KOHZU;
                Pattern.Add(m);

                //܂TAꂩcT
                numHai_tmp[(int)state.AgariHai] -= 3;
                Enum_Jantoh(ArrayPattern, Pattern, numHai_tmp);
                numHai_tmp[(int)state.AgariHai] += 3;
            }

            //ȂǏオ肪q̃p^[
            if (state.AgariHai <= Hai.SOUZU_9) {
                //[𖄂߂Ă̏オp^[
                if (((int)state.AgariHai) % 10 <= 7 && numHai_tmp[(int)state.AgariHai] > 0 &&
                    numHai_tmp[(int)state.AgariHai + 1] > 0 && numHai_tmp[(int)state.AgariHai + 2] > 0) {
                    Pattern = new List<Mentsu_State>();
                    m = new Mentsu_State();
                    m.top = state.AgariHai;
                    m.type = Mentsu.SHUNZU;
                    Pattern.Add(m);
                    //܂TAꂩcT
                    numHai_tmp[(int)state.AgariHai]--;
                    numHai_tmp[(int)state.AgariHai + 1]--;
                    numHai_tmp[(int)state.AgariHai + 2]--;
                    Enum_Jantoh(ArrayPattern, Pattern, numHai_tmp);
                    numHai_tmp[(int)state.AgariHai]++;
                    numHai_tmp[(int)state.AgariHai + 1]++;
                    numHai_tmp[(int)state.AgariHai + 2]++;
                }
                //J`ł̃p^[
                if (((int)state.AgariHai) % 10 >= 2 && ((int)state.AgariHai) % 10 <= 8 && numHai_tmp[(int)state.AgariHai - 1] > 0 &&
                    numHai_tmp[(int)state.AgariHai] > 0 && numHai_tmp[(int)state.AgariHai + 1] > 0) {
                    Pattern = new List<Mentsu_State>();
                    m = new Mentsu_State();
                    m.top = state.AgariHai - 1;
                    m.type = Mentsu.SHUNZU;
                    Pattern.Add(m);
                    //܂TAꂩcT
                    numHai_tmp[(int)state.AgariHai]--;
                    numHai_tmp[(int)state.AgariHai + 1]--;
                    numHai_tmp[(int)state.AgariHai - 1]--;
                    Enum_Jantoh(ArrayPattern, Pattern, numHai_tmp);
                    numHai_tmp[(int)state.AgariHai]++;
                    numHai_tmp[(int)state.AgariHai + 1]++;
                    numHai_tmp[(int)state.AgariHai - 1]++;
                }
                //E𖄂߂Ă̏オp^[
                if (((int)state.AgariHai) % 10 >= 3 && numHai_tmp[(int)state.AgariHai - 2] > 0 &&
                    numHai_tmp[(int)state.AgariHai - 1] > 0 && numHai_tmp[(int)state.AgariHai] > 0) {
                    Pattern = new List<Mentsu_State>();
                    m = new Mentsu_State();
                    m.top = state.AgariHai - 2;
                    m.type = Mentsu.SHUNZU;
                    Pattern.Add(m);
                    //܂TAꂩcT
                    numHai_tmp[(int)state.AgariHai]--;
                    numHai_tmp[(int)state.AgariHai - 1]--;
                    numHai_tmp[(int)state.AgariHai - 2]--;
                    Enum_Jantoh(ArrayPattern, Pattern, numHai_tmp);
                    numHai_tmp[(int)state.AgariHai]++;
                    numHai_tmp[(int)state.AgariHai - 1]++;
                    numHai_tmp[(int)state.AgariHai - 2]++;
                }

            }


            return;
        }

        //Ύq̖ʎq\邩`FbN
        private void Enum_Chitoitsu(List<List<Mentsu_State>> ArrayPattern) {
            List<Mentsu_State> Pattern;
            int i, num = 0;

            //numHai2ł鍀ڂJEg
            for (i = 1; i < (int)Hai.DUMMY_MAX; i++) {
                if (numHai[i] == 2) num++;
            }

            if (num != 7) return;

            Pattern = new List<Mentsu_State>();

            //܂͏オv̖ʎqXgɉ
            i = (int)state.AgariHai;
            Mentsu_State ms = new Mentsu_State();
            ms.type = Mentsu.TOIZU;
            ms.top = (Hai)i;

            Pattern.Add(ms);

            //オvȊOnumHai2ł鍀ڂJEg
            for (i = 1; i < (int)Hai.DUMMY_MAX; i++) {
                if (numHai[i] == 2 && i != (int)state.AgariHai) {
                    ms = new Mentsu_State();
                    ms.type = Mentsu.TOIZU;
                    ms.top = (Hai)i;
                    Pattern.Add(ms);
                }
            }

            ArrayPattern.Add(Pattern);
            return;

        }

        #endregion


        //14ʎq̃I[\hbNXȃp^[
        private void Calc_Score(List<Mentsu_State> Pattern) {
            MJState_Result mjr = new MJState_Result();
            mjr.AgariHai = state.AgariHai;
            mjr.ArrayMentsu = Pattern;

            //܂A𖞂`FbN
            CheckYaku_Tsuiso(mjr); //F
            CheckYaku_Suankoh(mjr); //lÍElȎq
            CheckYaku_Sushi(mjr); //lEl
            CheckYaku_Daisangen(mjr); //O
            CheckYaku_Daisharin(mjr); //ԗ
            CheckYaku_Churen(mjr); //A
            CheckYaku_Ryuiso(mjr); //ΈF
            CheckYaku_Chinroto(mjr); //V

            //𖞂Pł΂ŏI
            if (mjr.Score_Yakuman > 0) {
                result.Add(mjr);
                return;
            }
            //͖𖞈ȊO̒ʏ픻
            CheckYaku_Richi(mjr); //[`E_u[`
            CheckYaku_Tsumo(mjr); //cEꔭE`JEV𔻒
            CheckYaku_Yakuhai(mjr); //v
            CheckYaku_Haitei(mjr); //nCeC

            CheckYaku_Tanyao(mjr); //^IE`^E`
            CheckYaku_Chinitsu(mjr); //FEF̔
            CheckYaku_Sananko(mjr); //OÍEOȎqE΁Xa̔
            CheckYaku_Shosangen(mjr); //O̔
            CheckYaku_Pinfu(mjr); //stقAqn̖(uEuECʊсEOF)łɎOF
            CheckYaku_Chitoitsu(mjr); //Ύq

            //܂ŖȂΏI
            if (mjr.ArrayYaku.Count == 0)
                return;

            //h͍Ō
            CheckYaku_Dora(mjr);@//\hEh

            //̃JEg
            Count_Fu(mjr);

            //Ɩ_vZ
            Calc_Score_fin(mjr);

            //ǉďI
            result.Add(mjr);

        }


        private void CheckAgari() {
            List<List<Mentsu_State>> ArrayPattern = new List<List<Mentsu_State>>();

            //ȖƂčmo`FbN
            if (CheckYaku_Kokushi())
                return;

            //ŏhJEg
            CountDora();

            //XRȂOɁA܂͖ʎqm肳
            //Ύq`FbN
            Enum_Chitoitsu(ArrayPattern);

            //͂PSʎq̌``FbN
            Enum_Patterm(ArrayPattern);

            //X̃p^[ɑ΂AXRA
            foreach (List<Mentsu_State> Pat in ArrayPattern) {
                Calc_Score(Pat);
            }


            return;
        }


        public List<MJState_Result> Resolve(MJState state_) {

            // ϐ
            state = state_;
            result = new List<MJState_Result>();
            ErrorStr = "";

            //܂オvOɔv̐JEg
            if (CheckValidation() == false) return result;

            if (state.AgariHai == Hai.EMPTY) {
                //オvŵȂꍇAevɑ債ă`FbN
                for (int i = 1; i < (int)Hai.DUMMY_MAX; i++) {
                    if (i == (int)Hai.PEI + 1 || (i % 10 == 0)) continue; 
                    state.AgariHai = (Hai)i;
                    if (CheckValidation()) {
                        CheckAgari();
                    }
                }
                ErrorStr = "";
                state.AgariHai = Hai.EMPTY;

            }
            else {
                CheckAgari();
            }

            //ʂ̕בւ
            result.Sort(delegate(MJState_Result l, MJState_Result r) {
                int s = r.Score_Total.CompareTo(l.Score_Total);
                return (s!=0 ? s :l.AgariHai.CompareTo(r.AgariHai));
            }); 

            return result;
        }

        private bool CheckValidation() {
            //v̏ԂsȂmF
            int i;
            bool ok;

            //[`╗̊mF
            if (state.Richi < 0 || state.Richi > 2) {
                ErrorStr = "[`̎w肪słB";
                return false;
            }
            //[`ƈÃJȊO̖͓ɐ藧Ȃ
            if (state.Richi > 0) {
                ok = true;
                foreach (Mentsu_State ms in state.ArrayNaki) {
                    if (ms.naki) ok = false;
                }
                if (!ok) {
                    ErrorStr = "܂܃[`͂ł܂B";
                    return false;
                }
            }

            //VJCzE̓JKvA܂c
            if (state.Rinshan) {
                if (!state.TsumoAgari) {
                    ErrorStr = "VJCzE̓cオ̂݉\łB";
                    return false;
                }
                ok = false;
                foreach (Mentsu_State ms in state.ArrayNaki) {
                    if (ms.type == Mentsu.KANZU) ok = true;
                }
                if (!ok) {
                    ErrorStr = "JȂꍇɃVJCzE͂ł܂B";
                    return false;
                }
            }

            //`J̓
            if (state.Chankan && state.TsumoAgari) {
                ErrorStr = "`J̓̂݉\łB";
                return false;
            }

            //ꔭ̓cEÃJȊO̖ȂE[`肪Kv
            if (state.Ippatsu) {
                if (!state.TsumoAgari) {
                    ErrorStr = "ꔭ̓cオ̂݉\łB";
                    return false;
                }
                if (state.Richi == 0) {
                    ErrorStr = "ꔭ̓[`KvłB";
                    return false;
                }
                //[`̖͏Ŋς

            }

            //̏
            for (i = 0; i < numHai.Length; i++) numHai[i] = 0;
            numOmoteDora = numUraDora = 0;


            //h\vJEg
            foreach (Hai h in state.OmoteDora) {
                if (h != Hai.EMPTY) numHai[(int)h]++;
            }
            foreach (Hai h in state.UraDora) {
                if (h != Hai.EMPTY) numHai[(int)h]++;
            }

            // ṽJEg
            foreach (Mentsu_State ns in state.ArrayNaki) {
                if (ns.top == Hai.EMPTY) {
                    ErrorStr = "ݒ̖܂B";
                    return false;
                }
                if (ns.type == Mentsu.KOHZU) numHai[(int)ns.top] += 3;
                else if (ns.type == Mentsu.KANZU) numHai[(int)ns.top] += 4;
                else {
                    numHai[(int)ns.top]++;
                    numHai[1 + (int)ns.top]++;
                    numHai[2 + (int)ns.top]++;
                }
            }

            // ṽJEg
            if (state.Jihai.Count != 13 - state.ArrayNaki.Count * 3) {
                ErrorStr = "vׂĎw肳Ă܂B";
                return false;
            }
            foreach (Hai h in state.Jihai) {
                    numHai[(int)h]++;
            }

            // オṽJEg
            if (state.AgariHai != Hai.EMPTY){
                int hi = (int)state.AgariHai;
                numHai[hi]++;
            }


            //5ȏ̂̂ƃAEg
            foreach (int j in numHai) {
                if (j > 4) {
                    ErrorStr = "5ȏ܂܂Ăv܂B";
                    return false;
                }
            }
            // h\v߂
            foreach (Hai h in state.OmoteDora) {
                if (h != Hai.EMPTY) numHai[(int)h]--;
            }
            foreach (Hai h in state.UraDora) {
                if (h != Hai.EMPTY) numHai[(int)h]--;
            }
            return true;

        }

    }
}
